<?php

/* NoPro handy-lib
 * some handy defs and funcs
 */

if(!defined('CRLF')) define('CRLF', "\r\n");

function sqltimedate($date) {
  return date("Y-m-d H:i:s", strtotime($date));
}

function arr2tbl($arr, $cap) {
  // output html-table from array of assoc-arrays
  echo '  <table class="sqlres">' .CRLF;
  echo "    <caption>$cap</caption>" .CRLF;
  echo "    <tr>";
  foreach($arr[0] as $k => $v) {
    echo "      <th>". htmlify_sec($k) ."</th>" .CRLF;
  }
  echo "    </tr>" .CRLF;
  foreach($arr as $row) {
    echo "    <tr>" .CRLF;
    foreach($row as $k => $v) {
      echo "      <td>". htmlify_sec($v) ."</td>".CRLF;
    }
    echo "    </tr>" .CRLF;
  }
  echo "  </table>" .CRLF;
}

function npget_http($url, $chunked=false) {
  if(!$chunked && function_exists('http_get')) {
    // use pecl http-extension
    $html = http_get($url);
  } else {
    // use curl
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    //curl_setopt($ch, CURLOPT_NOBODY, 0);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_MAXREDIRS, 2);
    curl_setopt($ch, CURLOPT_COOKIEFILE, '');
    curl_setopt($ch, CURLOPT_COOKIEJAR, '');
    curl_setopt($ch, CURLOPT_TIMEOUT, 25);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    $html = curl_exec($ch);
    curl_close($ch);
  }
  return $html;
}

function npget_mywebip($k = 0) {
  $pool = array(
		array("myip.sonyonline.net/", '-- You Are ', true),		// no regex
		# array("myip.sonyonline.net/", "/-- You Are \r\n../"),		// chunks 30 + ea + 1d + 19 + 3b but needs regex
		## array("myip.dk", 'IP Address:</b> <span class="ha4">'),	// 6024 not working anymore since 2012-09
		## array("myip.utilities-online.info/", "My ip is: "),		// chunks long  not working anymore since 2012-11
		array('whatismyipaddress.com/', '<!-- do not script -->'),	// next line
		array("www.ip-adress.com/IP_adresse/", "Meine IP: "),		// len: 5853 *but slow*
		array("myip.nmonitoring.com/", "<a href='http://whois.nmonitoring.com?ip="),	// chunks VERY long
	       );
  if($k<0 || $k>count($pool)) $k=0;
  list($site, $ptrn, $chunked) = $pool[$k];

  $html = npget_http("http://$site", $chunked);  
  #die($html);
  $pl = strlen($ptrn);
  $bp = stripos($html, $ptrn);
  $bp += $pl + strspn($html, "\r\n\t ", $bp + $pl);
  $len = strspn($html, ".0123456789", $bp);
  return substr($html, $bp, $len);
}

function htmlify($s) {
  // replace umlauts only
  $patt = array('//',    '//',    '//',    '//',     '//',    '//',    '//',    '//');
  $repl = array('&auml;', '&ouml;', '&uuml;', '&szlig;', '&Auml;', '&Ouml;', '&Uuml;', '&eacute;');
  return preg_replace($patt, $repl, $s);
}

function htmlify_sec($s) {
  // replace some more - and umlauts
  $patt = array('/&/',   '/</');
  $repl = array('&amp;', '&lt;');
  return htmlify(preg_replace($patt, $repl, $s));
}

function hexfill($o) {
  if(($o & 0xf) == 0)
    return;
  for($i = 0; $i < $o & 0xf; $i++)
    if($i > 0 && $i % 4 == 0)
      echo "    ";
    else
      echo "   ";
}
  
function hexdump($str, $len=0, $offset=0) {

  $a0 = "  ";
  
  if($len === 0)
    $len = strlen($str) - $offset;
  $asc = $a0 . substr("                ", 0, $offset & 0xf);

  hexfill($offset);
  for($i = 0; $i < $len; $i++) {
    $o = $offset + $i;
    if($o > 0 && $o % 16 == 0) {
      echo $asc .PHP_EOL;
      $asc = $a0;
    } else if($o > 0 && $o % 4 == 0)
      echo " ";
    $cc = substr($str, $o, 1);
    $ca = ord($cc);
    $asc .= ($ca > 0x20 && $ca < 0x7f) ? $cc : '.';
    printf("%02x ", $ca);
  }
  hexfill(15 - ($o & 0xf));
  if($asc != $a0) {
    echo $asc .PHP_EOL;
  }
}

?>
