<?php

/* NoPro sql-lib
 * some handy funcs using mysqli-object
 */

function sqlistore($dbo, $tbl, $arr, $idkey = null, $verbose = null, $keys = null) {
  /* the presence of $idkey, signals UPDATE instead of INSERT
   * $verbose means to print the query
   * $keys for non-associative $arr, or to override $k from $arr
   */
  $query = $idkey ? "INSERT INTO $tbl SET" : "UPDATE $tbl SET";
  foreach($arr as $k => $val) {
    $key = $keys ? $keys[$k] : $k;
    if(is_numeric($val))
      $query .= " $key = $val,";
    else if($val === null)
      $query .= " $key = NULL,";
    else
      $query .= " $key = '$val',";
  }
  $query = rtrim($query, ',');
  
  if($idkey)
    $query .= sprintf(" WHERE $idkey = %d", $arr[$idkey]);
  
  if($verbose)
    echo $query ."\n";
  
  $dbo->query($query) or die("sqlstore(): ". $dbo->error);
  if($idkey)
    $idval = $arr[$idkey];
  else
    $idval = $dbo->insert_id;
  return $idval;
}

function sqli2arr($dbo, $query) {
  # fill array with sql-results
  $arr = array();
  $res = $dbo->query($query) OR die("query(): ".$dbo->error);
  while($row = $res->fetch_assoc()) {
    array_push($arr, $row);
  }
  $res->close();
  return $arr;
}

?>